--- a/dist/configure.in
+++ b/dist/configure.in
@@ -105,7 +105,7 @@
 
 dnl A/UX has a broken getopt(3), strpbrk(3).
 case "$host_os" in
-aux*)	   LIBOBJS="getopt.o strpbrk.o $LIBOBJS";;
+aux*)	   LIBOBJS="libvi_la-getopt.o libvi_la-strpbrk.o $LIBOBJS";;
 esac
 
 dnl Ultrix has a broken POSIX.1 VDISABLE value.
@@ -434,7 +434,7 @@
         	-e 'ldopts'`
 	perlldflags=`cd $srcdir;$vi_cv_path_perl -MExtUtils::Embed \
         	-e 'ccdlflags'`
-	LIBOBJS="perl.o perlxsi.o perlsfio.o $LIBOBJS"
+	LIBOBJS="libvi_la-perl.o libvi_la-perlxsi.o libvi_la-perlsfio.o $LIBOBJS"
 	AC_DEFINE(HAVE_PERL_INTERP)
 	AC_CACHE_CHECK([whether we need to use perl's setenv], 
 		vi_cv_perl_setenv, [
@@ -471,7 +471,7 @@
 		AC_MSG_ERROR([No Tcl library found;])
 	fi
 	. $vi_cv_tclconfig
-	LIBOBJS="tcl.o $LIBOBJS"
+	LIBOBJS="libvi_la-tcl.o $LIBOBJS"
 	LIBS="$TCL_LIB_SPEC $TCL_LIBS $LIBS"
 	AC_DEFINE(HAVE_TCL_INTERP)
 fi
@@ -607,12 +607,12 @@
 
 dnl If we needed setenv or unsetenv, add in the clib/env.c replacement file.
 if test "$need_env" = yes; then
-	LIBOBJS="env.o $LIBOBJS"
+	LIBOBJS="libvi_la-env.o $LIBOBJS"
 fi
 
 dnl If we need strsep, add it and define it so we get a prototype.
 if test "$need_strsep" = yes; then
-	LIBOBJS="strsep.o $LIBOBJS"
+	LIBOBJS="libvi_la-strsep.o $LIBOBJS"
 fi
 
 dnl Check for fcntl/flock
@@ -1003,7 +1003,7 @@
 	PATH="$OLDPATH"
 
 	AC_DEFINE(USE_DYNAMIC_LOADING)
-	LIBOBJS="dldb.o $LIBOBJS"
+	LIBOBJS="libvi_la-dldb.o $LIBOBJS"
 	dl_src=../common/dldb.c
 	LIBS="-ldl $LIBS"
 else
@@ -1046,9 +1046,9 @@
 	CPPFLAGS="-I$vi_cv_dbsrc/include_auto $CPPFLAGS"
 	CPPFLAGS="-I$with_db_build $CPPFLAGS"
 	AC_DEFINE(USE_DB4_LOGGING)
-	LIBOBJS="log4.o vi_auto.o vi_rec.o $LIBOBJS"
+	LIBOBJS="libvi_la-log4.o libvi_la-vi_auto.o libvi_la-vi_rec.o $LIBOBJS"
 else
-	LIBOBJS="log.o $LIBOBJS"
+	LIBOBJS="libvi_la-log.o $LIBOBJS"
 fi
 
 dnl We compile in nvi's RE routines unless the user specifies otherwise.
@@ -1064,7 +1064,7 @@
 case "$vi_cv_re_lib" in
 "bundled RE")
 	CPPFLAGS="-I\$(visrcdir)/regex $CPPFLAGS"
-	LIBOBJS="regcomp.o regerror.o regexec.o regfree.o $LIBOBJS";;
+	LIBOBJS="libvi_la-regcomp.o libvi_la-regerror.o libvi_la-regexec.o libvi_la-regfree.o $LIBOBJS";;
 "other RE")
 	;;
 esac
--- a/dist/Makefile.am
+++ b/dist/Makefile.am
@@ -169,12 +169,15 @@
 	$(visrcdir)/common/pthread.c \
 	$(visrcdir)/common/vi_auto.c \
 	$(visrcdir)/common/vi_rec.c \
-	$(visrcdir)/perl_api/perl.xs \
+	perl.c \
 	$(visrcdir)/perl_api/perlsfio.c \
+	perlxsi.c \
 	$(visrcdir)/tcl_api/tcl.c
 # Is this the way to do it ?
 libvi_la_DEPENDENCIES = @LTLIBOBJS@
-libvi_la_LIBADD = @LTLIBOBJS@
+libvi_la_LIBADD = @LTLIBOBJS@ @perllibs@
+libvi_la_CPPFLAGS = @perlldflags@ $(AM_CPPFLAGS)
+libvi_la_LDFLAGS = @perlldflags@
 
 bin_PROGRAMS = @vi_programs@ @vi_ipc@
 EXTRA_PROGRAMS = vi vi-ipc vi-motif vi-gtk
